unit classUnit;

interface

uses
    Evalcomp;

type
TChromosome = class(TObject)
    public
        len      :integer;           // 
        body     :array of boolean;  // 
        f        :double;            //  
        time_life:integer;           //  
        constructor Create(l:integer);
        function    BINtoDEC:integer;
end;

TPopulation = class(TObject)
    private
        procedure Sort; //    
    public
        FORMULA: string;
        f_sum,          //   . 
        f_avg:double;   //  
        NumChrom,       //  
        LenChrom        :integer; // 
        LB,RB           :integer; //      x
        chrom_bank      :array of TChromosome;
        calc: EVALVEC ; //(evalvec -   ,  evalcomp)
        constructor Create(n,l,lft,rht:integer;sf:string); // ,     
        destructor  Destroy;
        function        fun(x:double):double;    //   -  
        procedure       delbad;                  //  , -     x
        procedure       crossingover(ver:double);
        procedure       mutation(ver:double;num:integer); // -     
        procedure       selection(num:integer);//  -  ,   
        procedure FillAll;
        function        allequal:boolean;
end;

implementation

uses
    Math,Dialogs;

//     HomeNum  EndNum  InArray  OutArray
procedure CopyArray(var OutArray,InArray:array of TChromosome;HomeNum,EndNum:integer);
var i,n1,n2:integer;
begin
  if HomeNum=-1 then n1:=Low(InArray) else n1:=HomeNum;
  if EndNum=-1 then n2:=High(InArray) else n2:=EndNum;
  for i:=n1 to n2 do OutArray[i]:=InArray[i];
end;
//     
procedure SwapValue(var Value1,Value2:double);
var
  temp:double;
begin
  temp:=Value1;
  Value1:=Value2;
  Value2:=temp;
end;
//    ( )
// (   ,      :) )
// FirstMin=True   , False- 
procedure SequencingArray(var InOutArray:array of double;FirstMin:boolean);
var
  i,j:integer;
begin
  for i:=Low(InOutArray) to High(InOutArray) do
    for j:=Low(InOutArray) to High(InOutArray)-1 do
    begin
      if (InOutArray[j]<>InOutArray[j+1])
      then if InOutArray[j]>InOutArray[j+1]
           then begin
           				if FirstMin
                  then SwapValue(InOutArray[j],InOutArray[j+1])
                end
           else if not FirstMin
                then SwapValue(InOutArray[j],InOutArray[j+1]);
    end;
end;


/////////////////////////////////////////
//  TChromosome
/////////////////////////////////////////

constructor TChromosome.Create(l:integer);
var
    i:integer;
begin
    inherited   Create;
    len:=l;
    SetLength(body,len);
    for i:=0 to len-1 do
    //  
    if (random<0.5) then body[i]:=false else body[i]:=true;
end;

function    TChromosome.BINtoDEC:integer;
var
    i:integer;
    r:integer;
begin
    r:=1;
    result:=0;
    for i:=0 to len-1 do
    begin
        if body[i] then result:=result+r;
        r:=r*2;
    end;
end;

/////////////////////////////////////////
//  TPopulation
/////////////////////////////////////////

function TPopulation.fun(x:double):double;
begin
    result:=power(x,4)-250;
end;

procedure Tpopulation.FillAll;
var
    i:integer;
    s:double;
begin
    f_sum:=0;
    for i:=0 to NumChrom-1 do
    begin
        chrom_bank[i].f:=fun(chrom_bank[i].BINtoDEC);
        f_sum:=f_sum+fun(chrom_bank[i].BINtoDEC);
    end;
    f_avg:=f_sum/NumChrom;
end;

constructor TPopulation.Create(n,l,lft,rht:integer;sf:string);
var
    i:integer;
begin
    inherited Create;
    SetLength(chrom_bank,n);
    NumChrom:=n;
    LenChrom:=l;
    LB:=lft;
    RB:=rht;
    //  
    FORMULA:=sf;
    new (calc,init(FORMULA));   //(  )
    //  ,    
    for i:=0 to NumChrom-1 do chrom_bank[i]:=TChromosome.Create(LenChrom);
    FillAll;
end;

destructor TPopulation.Destroy;
begin
    dispose(calc,done); //(  )
    inherited Destroy;
end;

procedure TPopulation.delbad;
var
  ar:array of boolean;
  i,j,n,tn:integer;
begin
  SetLength(ar,NumChrom);
  for i:=0 to NumChrom-1 do ar[i]:=false;
  n:=0;
  for i:=0 to NumChrom-1 do
  begin
    if ((chrom_bank[i].BINtoDEC>=LB)and(chrom_bank[i].BINtoDEC<=RB))
    then begin
      ar[i]:=true;
      inc(n);
    end;
  end;
  if n<3 then
  begin
    MessageDlg('  '+#13+
    '   x'+#13+
    '   ', mtWarning, [mbOk], 0);
    ar:=NIL;
    exit;
  end;
  tn:=0;
  for i:=0 to NumChrom-1 do
  begin
    if ar[i] then begin
      for j:=0 to LenChrom-1 do chrom_bank[tn].body[j]:=chrom_bank[i].body[j];
      inc(tn);
    end;
  end;
  ar:=NIL;
  SetLength(chrom_bank,n);
  NumChrom:=Length(chrom_bank);
  FillAll;
end;

procedure Tpopulation.crossingover(ver:double);
var
  n1,n2,PointCross,i,ni,j:integer;
  v,is_found:boolean;
  is_chrom:array of boolean;
begin
  //     

  //      
  //(-    )
  //     
  {
  for i:=0 to NumChrom-1 do
  begin
    n1:=random(NumChrom);
    n2:=random(NumChrom);
    PointCross:=random(LenChrom);
    for j:=PointCross to LenChrom-1 do
    begin
      v:=chrom_bank[n1].body[j];
      chrom_bank[n1].body[j]:=chrom_bank[n2].body[j];
      chrom_bank[n2].body[j]:=v;
    end;
  end;
  }
  {
       
      ,       -
    ,  2 ,
       2 
  (   ,     1   )
     (      
  }
  SetLength(is_chrom,NumChrom); //    
  for i:=0 to NumChrom-1 do is_chrom[i]:=false;
  i:=0;ni:=NumChrom;
  while i<(NumChrom div 2) do
  begin
    //   2   
    
    //   
    is_found:=false;
    while not is_found do
    begin
        n1:=random(NumChrom);
        if not is_chrom[n1]
        then begin
            is_chrom[n1]:=true;
            is_found:=true;
        end;
    end;
    is_found:=false;
    while not is_found do
    begin
        n2:=random(NumChrom);
        if not is_chrom[n2]
        then begin
            is_chrom[n2]:=true;
            is_found:=true;
        end;
    end;
    {
    //     
    Sort;
    pr:=random;
    for i:=0 to NumChrom-2 do
    if ((chrom_bank[i].f/f_sum)>pr)and((chrom_bank[i+1].f/f_sum)<pr) then n1:=i+1;
    pr:=random;
    for i:=0 to NumChrom-2 do
    if ((chrom_bank[i].f/f_sum)>pr)and((chrom_bank[i+1].f/f_sum)<pr) then n2:=i+1;
    }
    if (random<ver) then
    begin
        SetLength(chrom_bank,Length(chrom_bank)+2);
        PointCross:=1+random(LenChrom-1);
        chrom_bank[ni]:=TChromosome.Create(LenChrom);
        chrom_bank[ni+1]:=TChromosome.Create(LenChrom);
        for j:=0 to LenChrom-1 do
        begin
            if j<PointCross
            then begin
                chrom_bank[ni].body[j]:=chrom_bank[n1].body[j];
                chrom_bank[ni+1].body[j]:=chrom_bank[n2].body[j];
            end
            //    
            else begin
                chrom_bank[ni].body[j]:=chrom_bank[n2].body[j];
                chrom_bank[ni+1].body[j]:=chrom_bank[n1].body[j];
            end;
        end;
        ni:=ni+2;
    end;
    inc(i);
  end;
  is_chrom:=NIL;
  NumChrom:=Length(chrom_bank);
  FillAll;
end;

procedure TPopulation.Sort;
var
  i,j,k:integer;
  v:boolean;
  dv:double;
begin
  for i:=0 to NumChrom-1 do
  begin
    for j:=0 to NumChrom-2 do
    begin
      if chrom_bank[j+1].f>chrom_bank[j].f
      then begin
        for k:=0 to LenChrom-1 do
        begin
          v:=chrom_bank[j].body[k];
          chrom_bank[j].body[k]:=chrom_bank[j+1].body[k];
          chrom_bank[j+1].body[k]:=v;
        end;
        dv:=chrom_bank[j].f;
        chrom_bank[j].f:=chrom_bank[j+1].f;
        chrom_bank[j+1].f:=dv;
      end;
    end;
  end;
  FillAll;
end;

procedure TPopulation.selection(num:integer);
begin
  Sort;
  SetLength(chrom_bank,num);
  NumChrom:=Length(chrom_bank);
  FillAll;
  //SetLength(ar,NumChrom);
  //CopyArray(ar,chrom_bank,-1,-1);
  //chrom_bank:=NIL;
  {
  n:=0;
  for j:=0 to NumChrom-1 do
  begin
    max:=chrom_bank[0].f;
    pos:=-1;
    for i:=0 to NumChrom-1 do
    begin
        if ((chrom_bank[i].f>=max) and (not is_chrom[i]) and (n<num))
        then begin
           max:=ar[i].f;
           pos:=i;
        end;
    end;
    if pos<>-1 then
    begin
        is_chrom[pos]:=true;
        inc(n);
    end;
  end;
  //SetLength(chrom_bank,n);
  j:=0;
  for i:=0 to NumChrom-1 do
  if is_chrom[i]
  then begin
    chrom_bank[j]:=ar[i];
    inc(j);
  end;
  ar:=NIL;
  is_chrom:=NIL;
  NumChrom:=n;
  }
end;

procedure    TPopulation.mutation(ver:double;num:integer);
var
  i,ch,pos:integer;
begin
  //   ,    (aka ZoneNuclearCrash)
  // BSP c8  include e:\coding\nuclear  22.12.1999
  // ^^^
  for i:=0 to num-1 do
  begin
    if random<ver
    then begin
        ch:=random(NumChrom);
        pos:=random(LenChrom);
        chrom_bank[ch].body[pos]:=not chrom_bank[ch].body[pos];
    end;
  end;
  FillAll;
end;

function    Tpopulation.allequal:boolean;
var
  i:integer;
begin
  result:=true;
  for i:=0 to NumChrom-2 do if (chrom_bank[i].BINtoDEC<>chrom_bank[i+1].BINtoDEC)
  then begin
    result:=false;
    break;
  end;
end;

end.
